"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CollapsibleSection = CollapsibleSection;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireDefault(require("react"));
var _icons = require("@gravity-ui/icons");
var _cn = require("../../helpers/cn");
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var block = (0, _cn.dfCN)('collapsible-section');
function CollapsibleSection(_ref) {
  var className = _ref.className,
    alwaysExpanded = _ref.alwaysExpanded,
    initialCollapsed = _ref.initialCollapsed,
    children = _ref.children,
    caption = _ref.caption,
    captionClassName = _ref.captionClassName;
  var _React$useState = _react.default.useState(initialCollapsed && !alwaysExpanded),
    _React$useState2 = (0, _slicedToArray2.default)(_React$useState, 2),
    collapsed = _React$useState2[0],
    setCollapsed = _React$useState2[1];
  var handleToggle = _react.default.useCallback(function () {
    setCollapsed(!collapsed);
  }, [collapsed]);
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("section", {
    className: block(null, className),
    children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)("h2", {
      className: block('caption', {
        collapsed: collapsed,
        collapsible: !alwaysExpanded
      }, captionClassName),
      onClick: alwaysExpanded ? undefined : handleToggle,
      children: [caption, !alwaysExpanded && /*#__PURE__*/(0, _jsxRuntime.jsxs)("span", {
        children: [" ", collapsed ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_icons.ChevronDown, {}) : /*#__PURE__*/(0, _jsxRuntime.jsx)(_icons.ChevronUp, {})]
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)("section", {
      className: block('content', {
        collapsed: collapsed
      }),
      children: children
    })]
  });
}
// #sourceMappingURL=CollapsibleSection.js.map
// #sourceMappingURL=CollapsibleSection.js.map