"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _react = _interopRequireDefault(require("react"));
var _cn = require("../../helpers/cn");
var _Icon = require("../Icon/Icon");
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var block = (0, _cn.dfCN)('editable-list');
EditableListItem.defaultProps = {
  itemRenderer: function itemRenderer(item) {
    return item.title;
  }
};
function EditableListItem(_ref) {
  var index = _ref.index,
    className = _ref.className,
    item = _ref.item,
    frozen = _ref.frozen,
    toggleRemove = _ref.toggleRemove,
    itemRenderer = _ref.itemRenderer;
  var onClick = _react.default.useCallback(function () {
    toggleRemove(item, index);
  }, [item, toggleRemove, index]);
  var icon = item.removed ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon.RepeatIcon, {}) : /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon.CloseIcon, {});
  var hasActions = !frozen && !item.frozen;
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("span", {
    className: block('item', className),
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
      className: block('item-content', {
        removed: item.removed
      }),
      title: item.title,
      children: itemRenderer(item)
    }), hasActions && /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
      className: block('item-action'),
      onClick: onClick,
      children: icon
    })]
  });
}
var EditableList = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(EditableList, _React$Component);
  var _super = (0, _createSuper2.default)(EditableList);
  function EditableList() {
    var _this;
    (0, _classCallCheck2.default)(this, EditableList);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      showAll: false
    };
    _this.renderItem = function (item, index) {
      var _this$props = _this.props,
        itemClassName = _this$props.itemClassName,
        itemRenderer = _this$props.itemRenderer,
        frozen = _this$props.frozen;
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(EditableListItem, {
        className: itemClassName,
        index: index,
        item: item,
        frozen: frozen,
        toggleRemove: _this.toggleRemove,
        itemRenderer: itemRenderer
      }, index);
    };
    _this.toggleRemove = function (item, index) {
      var _this$props2 = _this.props,
        value = _this$props2.value,
        onChange = _this$props2.onChange;
      var res = (0, _toConsumableArray2.default)(value);
      res[index] = (0, _objectSpread2.default)((0, _objectSpread2.default)({}, item), {}, {
        removed: !item.removed
      });
      onChange(res);
    };
    _this.onShowAll = function () {
      _this.setState({
        showAll: !_this.state.showAll
      });
    };
    return _this;
  }
  (0, _createClass2.default)(EditableList, [{
    key: "renderShowAll",
    value: function renderShowAll() {
      var showAll = this.state.showAll;
      var text = showAll ? 'Hide' : 'Show all';
      return /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
        className: block('show-all'),
        onClick: this.onShowAll,
        children: text
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        className = _this$props3.className,
        value = _this$props3.value,
        maxVisibleCount = _this$props3.maxVisibleCount;
      var showAll = this.state.showAll;
      var itemsToRender = !showAll && maxVisibleCount ? value.slice(0, maxVisibleCount) : value;
      var showAllVisible = showAll || itemsToRender.length !== value.length;
      return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
        className: block(null, className),
        children: [itemsToRender.map(this.renderItem), showAllVisible && this.renderShowAll()]
      });
    }
  }], [{
    key: "getDefaultValue",
    value: function getDefaultValue() {
      return [];
    }
  }, {
    key: "isEmpty",
    value: function isEmpty() {
      return false;
    }
  }]);
  return EditableList;
}(_react.default.Component);
EditableList.defaultProps = {
  value: []
};
var _default = EditableList; // #sourceMappingURL=EditableList.js.map
exports.default = _default;
// #sourceMappingURL=EditableList.js.map