"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FocusBlurContainer = FocusBlurContainer;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireDefault(require("react"));
var _useStableEventHendler = require("../../helpers/useStableEventHendler");
var _utils = require("../Dialog/utils");
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function noop() {}
function FocusBlurContainer(_ref) {
  var children = _ref.children,
    className = _ref.className,
    onFocus = _ref.onFocus,
    _ref$onBlur = _ref.onBlur,
    onBlur = _ref$onBlur === void 0 ? noop : _ref$onBlur;
  var _React$useState = _react.default.useState(false),
    _React$useState2 = (0, _slicedToArray2.default)(_React$useState, 2),
    focused = _React$useState2[0],
    setFocused = _React$useState2[1];
  var handleBlur = (0, _useStableEventHendler.useStableEventHandler)((0, _utils.applyFunctions)(onBlur, function () {
    setFocused(false);
  }));
  var handleFocus = useOnFocusOutside(handleBlur, focused);
  var handleClick = useOnClickOutside(handleBlur, focused);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
    className: className,
    onFocus: (0, _utils.applyFunctions)(handleFocus, onFocus, function () {
      setFocused(true);
    }),
    onClick: handleClick,
    children: children
  });
}
function useOnFocusOutside(onFocusOutside) {
  var enable = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var capturedRef = _react.default.useRef(false);
  _react.default.useEffect(function () {
    if (enable) {
      var handleFocus = function handleFocus() {
        capturedRef.current = false;
        window.setTimeout(function () {
          if (!capturedRef.current) {
            onFocusOutside();
          }
        }, 0);
      };
      window.addEventListener('focus', handleFocus, {
        capture: true
      });
      return function () {
        window.removeEventListener('focus', handleFocus, {
          capture: true
        });
      };
    }
    return undefined;
  }, [enable, onFocusOutside]);
  return _react.default.useCallback(function () {
    capturedRef.current = true;
  }, []);
}
function useOnClickOutside(onClickOutside) {
  var enable = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var capturedRef = _react.default.useRef(false);
  _react.default.useEffect(function () {
    if (enable) {
      var handleClick = function handleClick() {
        capturedRef.current = false;
        window.setTimeout(function () {
          if (!capturedRef.current) {
            onClickOutside();
          }
        }, 0);
      };
      window.addEventListener('click', handleClick, {
        capture: true
      });
      return function () {
        window.removeEventListener('click', handleClick, {
          capture: true
        });
      };
    }
    return undefined;
  }, [enable, onClickOutside]);
  return _react.default.useCallback(function () {
    capturedRef.current = true;
  }, []);
}
// #sourceMappingURL=FocusBlurContainer.js.map
// #sourceMappingURL=FocusBlurContainer.js.map