"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useStableEventHandler = useStableEventHandler;
var _react = _interopRequireDefault(require("react"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function error() {
  throw new Error('Cannot call an event handler while rendering or after unmount.');
}
function useStableEventHandler(func) {
  var ref = _react.default.useRef(error);
  _react.default.useEffect(function () {
    ref.current = func;
    return function () {
      ref.current = error;
    };
  }, [func]);
  return _react.default.useCallback(function () {
    var _ref$current;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    return (_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.call.apply(_ref$current, [ref].concat(args));
  }, []);
}
// #sourceMappingURL=useStableEventHendler.js.map
// #sourceMappingURL=useStableEventHendler.js.map