import _find from 'lodash/find';
var TAB_ID = 'id';
export function getTabId(tabValues) {
  return tabValues[TAB_ID];
}
export function checkTabId(newTabData, tabs) {
  var id = getTabId(newTabData);
  if (id === undefined) {
    throw new Error('id field must be defined');
  }
  var tab = _find(tabs, function (tab) {
    return id === getTabId(tab);
  });
  if (tab) {
    throw new Error('id of a tab must be unique');
  }
}
export function applyFunctions() {
  for (var _len = arguments.length, fns = new Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }
  return function () {
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }
    return fns.forEach(function (fn) {
      return fn === null || fn === void 0 ? void 0 : fn.apply(void 0, args);
    });
  };
}
// #sourceMappingURL=utils.js.map