import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
var _excluded = ["value", "onChange", "onBlur", "onFocus", "disabled"];
import React, { Component } from 'react';
import _find from 'lodash/find';
import _findIndex from 'lodash/findIndex';
import { TextInput } from '@gravity-ui/uikit';
import { dfCN } from '../../helpers/cn';
import LabelsGroup from './LabelsGroup/LabelsGroup';
import { FocusBlurContainer } from '../FocusBlurContainer/FocusBlurContainer';
import './MultiTextControl.css';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var block = dfCN('multi-text-control');
var MultiTextControl = /*#__PURE__*/function (_Component) {
  _inherits(MultiTextControl, _Component);
  var _super = _createSuper(MultiTextControl);
  function MultiTextControl() {
    var _this;
    _classCallCheck(this, MultiTextControl);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      currentLabel: ''
    };
    _this.updateLabel = function (text) {
      _this.setState({
        currentLabel: text
      });
    };
    _this.confirmText = function () {
      var currentLabel = _this.state.currentLabel;
      if ((currentLabel === null || currentLabel === void 0 ? void 0 : currentLabel.length) > 0) {
        var _this$props = _this.props,
          onChange = _this$props.onChange,
          labels = _this$props.value;
        if (!_find(labels, function (label) {
          return label.name === currentLabel;
        })) {
          onChange(labels.concat({
            name: currentLabel
          }));
        }
        _this.setState({
          currentLabel: ''
        });
      }
    };
    _this.handleAdd = function (evt) {
      if (evt.keyCode === MultiTextControl.ENTER) {
        _this.confirmText();
      }
    };
    _this.handleClear = function () {
      _this.props.onChange(MultiTextControl.getDefaultValue());
    };
    _this.handleRemove = function (item) {
      var _this$props2 = _this.props,
        onChange = _this$props2.onChange,
        items = _this$props2.value;
      onChange(MultiTextControl.remove(item, items));
    };
    return _this;
  }
  _createClass(MultiTextControl, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        labels = _this$props3.value,
        _onChange = _this$props3.onChange,
        onBlur = _this$props3.onBlur,
        onFocus = _this$props3.onFocus,
        disabled = _this$props3.disabled,
        rest = _objectWithoutProperties(_this$props3, _excluded);
      return /*#__PURE__*/_jsxs(FocusBlurContainer, {
        className: block(),
        onBlur: onBlur,
        onFocus: onFocus,
        children: [/*#__PURE__*/_jsx(TextInput, _objectSpread(_objectSpread({
          size: "s",
          view: "normal",
          autoComplete: false,
          hasClear: true,
          disabled: disabled
        }, rest), {}, {
          onUpdate: this.updateLabel,
          onKeyDown: this.handleAdd,
          onBlur: this.confirmText,
          value: this.state.currentLabel
        })), /*#__PURE__*/_jsx(LabelsGroup, {
          items: labels,
          visibleCount: 4,
          disabled: disabled,
          onRemoveAll: this.handleClear,
          onRemove: this.handleRemove
        })]
      });
    }
  }], [{
    key: "getDefaultValue",
    value: function getDefaultValue() {
      return [];
    }
  }, {
    key: "isEmpty",
    value: function isEmpty(value) {
      return !value.length;
    }
  }, {
    key: "remove",
    value: function remove(theItem, items) {
      var index = _findIndex(items, function (anItem) {
        return theItem.name === anItem.name;
      });
      if (index > -1) {
        var copy = _toConsumableArray(items);
        copy.splice(index, 1);
        return copy;
      }
      return items;
    }
  }]);
  return MultiTextControl;
}(Component);
MultiTextControl.ENTER = 13;
MultiTextControl.hasErrorRenderer = true;
export default MultiTextControl;
// #sourceMappingURL=MultiTextControl.js.map